#
# Application Proxy
#

upstream sample {
        server {{ app_container }}:{{ app_port }};
}

server {
        listen 443;

        ssl                  on;
        ssl_certificate      /etc/letsencrypt/live/{{ fqdn }}/fullchain.pem;
        ssl_certificate_key  /etc/letsencrypt/live/{{ fqdn }}/privkey.pem;

        server_name {{ fqdn }};

        ssl_protocols TLSv1 TLSv1.1 TLSv1.2;
        ssl_ciphers 'ECDHE-RSA-AES128-GCM-SHA256:ECDHE-ECDSA-AES128-GCM-SHA256:ECDHE-RSA-AES256-GCM-SHA384:ECDHE-ECDSA-AES256-GCM-SHA384:DHE-RSA-AES128-GCM-SHA256:DHE-DSS-AES128-GCM-SHA256:kEDH+AESGCM:ECDHE-RSA-AES128-SHA256:ECDHE-ECDSA-AES128-SHA256:ECDHE-RSA-AES128-SHA:ECDHE-ECDSA-AES128-SHA:ECDHE-RSA-AES256-SHA384:ECDHE-ECDSA-AES256-SHA384:ECDHE-RSA-AES256-SHA:ECDHE-ECDSA-AES256-SHA:DHE-RSA-AES128-SHA256:DHE-RSA-AES128-SHA:DHE-DSS-AES128-SHA256:DHE-RSA-AES256-SHA256:DHE-DSS-AES256-SHA:DHE-RSA-AES256-SHA:AES128-GCM-SHA256:AES256-GCM-SHA384:AES128-SHA256:AES256-SHA256:AES128-SHA:AES256-SHA:AES:CAMELLIA:DES-CBC3-SHA:!aNULL:!eNULL:!EXPORT:!DES:!RC4:!MD5:!PSK:!aECDH:!EDH-DSS-DES-CBC3-SHA:!EDH-RSA-DES-CBC3-SHA:!KRB5-DES-CBC3-SHA';
        ssl_prefer_server_ciphers on;

        # It is *strongly* recommended to generate unique DH parameters
        # Generate them with: openssl dhparam -out /etc/nginx/dhparams.pem 2048
        ssl_dhparam /etc/nginx/dhparams.pem;

        gzip_proxied any;
        gzip_types text/plain text/css application/x-javascript
                text/xml application/xml application/xml+rss text/javascript
                application/json application/javascript;

        location / {
		proxy_set_header        Host $server_name;
		proxy_set_header        X-Real-IP $remote_addr;
		proxy_set_header        X-Forwarded-For $proxy_add_x_forwarded_for;
		proxy_set_header        X-Forwarded-Proto $scheme;
                proxy_pass http://wcui;
		proxy_read_timeout	300s;
        }

        error_page   500 502 503 504  /502.html;
        location = /502.html {
                root  /usr/share/nginx/html/;
        }
        location = /502.css {
                root  /usr/share/nginx/html/;
        }
        location = /favicon.ico {
                root  /usr/share/nginx/html/;
        }
        location = /large-logo.png {
                root  /usr/share/nginx/html/;
        }
        location = /status.html {
            root   html;
        }
        location = /ChimeraToken.txt {
            root   /usr/share/nginx/html/;
        }

}

#
# Redirect to secure site (return is more efficient than rewrite)
#
server {
       listen 80;
       server_name {{ fqdn }};
       return 301 https://{{ fqdn }}$request_uri;
}

#
# Default "Catch All" Server Block for http
#
server {
	listen 80 default_server;
	server_name _;	# Invalid value which will never match.
	server_name_in_redirect off;
	return 444;
}
